<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Unit Conversion and Dimensional Analysis Library: units::base_unit&lt; Meter, Kilogram, Second, Radian, Ampere, Kelvin, Mole, Candela, Byte &gt; Struct Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Unit Conversion and Dimensional Analysis Library
   &#160;<span id="projectnumber">2.3.0</span>
   </div>
   <div id="projectbrief">A compile-time c++14 unit conversion library</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespaceunits.html">units</a></li><li class="navelem"><a class="el" href="structunits_1_1base__unit.html">base_unit</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="structunits_1_1base__unit-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">units::base_unit&lt; Meter, Kilogram, Second, Radian, Ampere, Kelvin, Mole, Candela, Byte &gt; Struct Template Reference<div class="ingroups"><a class="el" href="group___unit_types.html">Unit Types</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>Class representing SI base unit types.  
 <a href="structunits_1_1base__unit.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="units_8h_source.html">units.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for units::base_unit&lt; Meter, Kilogram, Second, Radian, Ampere, Kelvin, Mole, Candela, Byte &gt;:</div>
<div class="dyncontent">
 <div class="center">
  <img src="structunits_1_1base__unit.png" alt=""/>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:af19df4880aef4620e2a52eab05981197"><td class="memItemLeft" align="right" valign="top"><a id="af19df4880aef4620e2a52eab05981197"></a>
typedef Meter&#160;</td><td class="memItemRight" valign="bottom"><b>meter_ratio</b></td></tr>
<tr class="separator:af19df4880aef4620e2a52eab05981197"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3ac2fe16787943979480726972f8d189"><td class="memItemLeft" align="right" valign="top"><a id="a3ac2fe16787943979480726972f8d189"></a>
typedef Kilogram&#160;</td><td class="memItemRight" valign="bottom"><b>kilogram_ratio</b></td></tr>
<tr class="separator:a3ac2fe16787943979480726972f8d189"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adc6beb1ccc9b812badfe70fa7d84023d"><td class="memItemLeft" align="right" valign="top"><a id="adc6beb1ccc9b812badfe70fa7d84023d"></a>
typedef Second&#160;</td><td class="memItemRight" valign="bottom"><b>second_ratio</b></td></tr>
<tr class="separator:adc6beb1ccc9b812badfe70fa7d84023d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4d4b25ecc3ef5a6a7feba0bb7438229a"><td class="memItemLeft" align="right" valign="top"><a id="a4d4b25ecc3ef5a6a7feba0bb7438229a"></a>
typedef Radian&#160;</td><td class="memItemRight" valign="bottom"><b>radian_ratio</b></td></tr>
<tr class="separator:a4d4b25ecc3ef5a6a7feba0bb7438229a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a72f099a82d381992e27cb1e951a6d603"><td class="memItemLeft" align="right" valign="top"><a id="a72f099a82d381992e27cb1e951a6d603"></a>
typedef Ampere&#160;</td><td class="memItemRight" valign="bottom"><b>ampere_ratio</b></td></tr>
<tr class="separator:a72f099a82d381992e27cb1e951a6d603"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6bdd72bc5315385d75d3baa9e9a9faeb"><td class="memItemLeft" align="right" valign="top"><a id="a6bdd72bc5315385d75d3baa9e9a9faeb"></a>
typedef Kelvin&#160;</td><td class="memItemRight" valign="bottom"><b>kelvin_ratio</b></td></tr>
<tr class="separator:a6bdd72bc5315385d75d3baa9e9a9faeb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af30c98d2c27be8a605a623aa8942fa5c"><td class="memItemLeft" align="right" valign="top"><a id="af30c98d2c27be8a605a623aa8942fa5c"></a>
typedef Mole&#160;</td><td class="memItemRight" valign="bottom"><b>mole_ratio</b></td></tr>
<tr class="separator:af30c98d2c27be8a605a623aa8942fa5c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ada202e7df1980e8bee827ce6003c57bc"><td class="memItemLeft" align="right" valign="top"><a id="ada202e7df1980e8bee827ce6003c57bc"></a>
typedef Candela&#160;</td><td class="memItemRight" valign="bottom"><b>candela_ratio</b></td></tr>
<tr class="separator:ada202e7df1980e8bee827ce6003c57bc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a95724e66bffee263658e60a50e56dfd6"><td class="memItemLeft" align="right" valign="top"><a id="a95724e66bffee263658e60a50e56dfd6"></a>
typedef Byte&#160;</td><td class="memItemRight" valign="bottom"><b>byte_ratio</b></td></tr>
<tr class="separator:a95724e66bffee263658e60a50e56dfd6"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;class Meter = detail::meter_ratio&lt;0&gt;, class Kilogram = std::ratio&lt;0&gt;, class Second = std::ratio&lt;0&gt;, class Radian = std::ratio&lt;0&gt;, class Ampere = std::ratio&lt;0&gt;, class Kelvin = std::ratio&lt;0&gt;, class Mole = std::ratio&lt;0&gt;, class Candela = std::ratio&lt;0&gt;, class Byte = std::ratio&lt;0&gt;&gt;<br />
struct units::base_unit&lt; Meter, Kilogram, Second, Radian, Ampere, Kelvin, Mole, Candela, Byte &gt;</h3>

<p>Class representing SI base unit types. </p>
<p>Base units are represented by a combination of <code>std::ratio</code> template parameters, each describing the exponent of the type of unit they represent. Example: meters per second would be described by a +1 exponent for meters, and a -1 exponent for seconds, thus: <code><a class="el" href="structunits_1_1base__unit.html" title="Class representing SI base unit types.">base_unit</a>&lt;std::ratio&lt;1&gt;, std::ratio&lt;0&gt;, std::ratio&lt;-1&gt;&gt;</code> </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">Meter</td><td><code>std::ratio</code> representing the exponent value for meters. </td></tr>
    <tr><td class="paramname">Kilogram</td><td><code>std::ratio</code> representing the exponent value for kilograms. </td></tr>
    <tr><td class="paramname">Second</td><td><code>std::ratio</code> representing the exponent value for seconds. </td></tr>
    <tr><td class="paramname">Radian</td><td><code>std::ratio</code> representing the exponent value for radians. Although radians are not SI base units, they are included because radians are described by the SI as m * m^-1, which would make them indistinguishable from scalars. </td></tr>
    <tr><td class="paramname">Ampere</td><td><code>std::ratio</code> representing the exponent value for amperes. </td></tr>
    <tr><td class="paramname">Kelvin</td><td><code>std::ratio</code> representing the exponent value for Kelvin. </td></tr>
    <tr><td class="paramname">Mole</td><td><code>std::ratio</code> representing the exponent value for moles. </td></tr>
    <tr><td class="paramname">Candela</td><td><code>std::ratio</code> representing the exponent value for candelas. </td></tr>
    <tr><td class="paramname">Byte</td><td><code>std::ratio</code> representing the exponent value for bytes. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="namespaceunits_1_1category.html" title="namespace representing the implemented base and derived unit types.">category</a> for type aliases for SI <a class="el" href="structunits_1_1base__unit.html" title="Class representing SI base unit types.">base_unit</a> types. </dd></dl>
</div><hr/>The documentation for this struct was generated from the following file:<ul>
<li>/mnt/e/workspace/units-master/include/<a class="el" href="units_8h_source.html">units.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Sat Oct 3 2020 11:16:53 for Unit Conversion and Dimensional Analysis Library by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
